stages:
  - build
  - test
  - staging
  - deploy

build_job:
  stage: build
  image: python:3.8-alpine
  script:
    - python setup.py bdist_wheel
  artifacts:
    paths:
    - dist

test_job:
  stage: test
  image: python:3.8-alpine
  script:
    - apk add build-base
    - pip install -r requirements/development.txt
    - pytest tests --cov package

build_image:
  stage: staging
  image: docker:19.03.1
  services:
    - docker:19.03.1-dind
  script:
    - docker login registry.gitlab.com -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker build -t registry.gitlab.com/ava.izet/devops-test .
    - docker push registry.gitlab.com/ava.izet/devops-test
  
deploy:
  stage: deploy
  image: docker:19.03.1
  services:
    - docker:19.03.1-dind
  script:
    - docker login registry.gitlab.com -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD
    - docker run -d -p 8085:8085 --name devops-test registry.gitlab.com/ava.izet/devops-test
  environment:
    name: dev
    url: http://35.242.228.69
